/* - This Source Code Form is subject to the terms of the Mozilla Public
   - License, v. 2.0. If a copy of the MPL was not distributed with this file,
   - You can obtain one at http://mozilla.org/MPL/2.0/. */

@import url("chrome://messenger/skin/shared/preferences/subdialog.css");

@namespace html url("http://www.w3.org/1999/xhtml");

:root {
  --in-content-button-border-radius: 3px;
}

@media not (prefers-contrast) {
  :root {
    --in-content-button-background: var(--grey-90-a10);
    --in-content-button-background-hover: var(--grey-90-a20);
    --in-content-button-background-active: var(--grey-90-a30);
    --in-content-categories-background: #ebebef;
    --in-content-item-selected-unfocused: var(--grey-20);
  }

  @media (prefers-color-scheme: dark) {
    :root {
      --in-content-categories-background: rgba(249, 249, 250, 0.1);
      --in-content-item-selected-unfocused: rgba(249, 249, 250, 0.05);
      --in-content-button-background: rgba(249, 249, 250, 0.1);
      --in-content-button-background-hover: rgba(249, 249, 250, 0.15);
      --in-content-button-background-active: rgba(249, 249, 250, 0.2);
      --in-content-primary-button-background: #45a1ff;
      --in-content-primary-button-background-hover: #65c1ff;
      --in-content-primary-button-background-active: #85e1ff;
      --in-content-focus-outline-color: #45a1ff;
    }
  }
}

@media (prefers-contrast) {
  :root {
    --in-content-categories-background: transparent;
  }
}

body {
  font-size: 1.1rem;
}

button,
menulist,
html|select,
html|input[type="color"] {
  min-height: var(--in-content-button-height);
}

search-textbox {
  min-height: var(--in-content-button-height);
}

button {
  padding: 0 12px;
}

menulist {
  padding: 0 6px;
}

button[open="true"],
menulist[open="true"] {
  color: var(--in-content-button-text-color-hover);
}

button,
menulist,
html|select,
html|input:is([type="email"],[type="number"],[type="color"],[type="text"],[type="password"],[type="url"]),
html|textarea,
search-textbox {
  border-radius: var(--in-content-button-border-radius);
}

#MailPreferences {
  text-rendering: optimizeLegibility;
}

#prefBox {
  position: relative;
}

#pref-category-box {
  background-color: var(--in-content-categories-background);
  width: 18em;
}

#categories > .category[selected] {
  font-weight: 500;
}

@media not (prefers-contrast) {
  #categories > .category[selected] {
    background-color: var(--in-content-button-background) !important;
    color: unset;
  }

  #categories > .category[selected]:focus {
    background-color: var(--in-content-item-selected) !important;
    color: var(--in-content-item-selected-text);
    outline: none;
  }
}

/* Temporary styles for the supernova icons */
.sidebar-footer-icon,
.category-icon {
  -moz-context-properties: fill, stroke, stroke-opacity;
  fill: color-mix(in srgb, currentColor 20%, transparent);
  stroke: currentColor;
}

.category-name {
  font-size: 1.1rem !important;
}

/*
  The stack has some very tall content but it shouldn't be taller than the
  viewport (and we know the tall content will still be accessible via scrollbars
  regardless if the stack has a shorter height). So we use min-height: 0 to allow
  the stack to be smaller than its content height so it can fit the viewport size.
*/
#preferences-stack {
  min-height: 0;
}

.main-content {
  padding: 0;
  height: 100vh;
}

/**
 * The first subcategory title for each category should not have margin-top.
 */

.subcategory:not([hidden]) ~ .subcategory {
  margin-top: 16px;
  padding-top: 16px;
  border-top: 1px solid var(--in-content-border-color);
}

fieldset {
  margin: 0 0 32px;
  padding: 0;
  border-style: none !important;
}

fieldset > hbox,
fieldset > vbox,
fieldset > radiogroup {
  width: -moz-available;
}

html|h1 {
  margin: 0 0 8px;
  font-size: 1.46em;
  font-weight: 300;
  line-height: 1.3em;
}

html|legend {
  margin: 16px 0 4px;
  font-size: 1.1em;
  font-weight: 600;
  line-height: 1.4em;
}

html|th {
  font-weight: normal;
  text-align: start;
}

description,
label {
  line-height: 1.8em;
  margin: 0;
}

button,
menulist::part(label-box) {
  font-weight: 400;
}

menulist::part(icon),
.folderMenuItem > .menu-iconic-left > .menu-iconic-icon {
  -moz-context-properties: fill, stroke;
  fill: color-mix(in srgb, currentColor 20%, transparent);
  stroke: currentColor;
}

menulist::part(label),
menuitem > label,
button > hbox > label {
  line-height: unset;
}

menulist::part(dropmarker-icon) {
  width: 16px;
  height: 16px;
  -moz-context-properties: stroke;
  stroke: currentColor;
}

.abMenuItem > .menu-iconic-left {
  display: block;
}

#preferencesContainer {
  padding: 0 28px 40px;
  overflow: auto;
}

.paneDeckContainer {
  display: block;
  width: 800px;
}

.sticky-container {
  width: 100%;
  position: sticky;
  background-color: var(--in-content-page-background);
  top: 0;
  z-index: 1;
  padding-inline: 4px;
}

#searchInput {
  min-height: var(--in-content-button-height);
  margin: 20px 0 30px;
}

#paneDeck {
  width: 100%;
}

.search-tooltip {
  max-width: 150px;
  font-size: 1.25rem;
  position: absolute;
  padding: 0 10px;
  background-color: #ffe900;
  color: #000;
  border: 1px solid #d7b600;
  bottom: 36px;
  opacity: 0.85;
}

.search-tooltip:hover {
  opacity: 0.1;
}

.search-tooltip::before {
  position: absolute;
  content: "";
  border: 7px solid transparent;
  border-top-color: #d7b600;
  top: 100%;
  inset-inline-start: calc(50% - 7px);
}

.search-tooltip::after {
  position: absolute;
  content: "";
  border: 6px solid transparent;
  border-top-color: #ffe900;
  top: 100%;
  inset-inline-start: calc(50% - 6px);
}

.search-tooltip-parent {
  position: relative;
}

.search-tooltip > span {
  user-select: none;
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
}

.tip-caption {
  font-size: .9em;
  color: var(--in-content-deemphasized-text);
}

.visually-hidden {
  visibility: collapse;
}

tabpanel > label,
tabpanel > description,
tabpanel > hbox > description {
  margin-inline-start: 0;
}

/* Web search menulist */
#defaultWebSearch::part(icon) {
  margin-inline: 5px 8px;
  width: 16px;
  height: 16px;
}

/* Category List */

#categories {
  overflow: visible !important; /* Cancel scrollbar and do not clip overflow content when window size goes very small */
}

#categories > .category {
  margin-inline: 6px;
}

.sidebar-footer-list {
  margin-inline: 0;
}

.sidebar-footer-icon {
  margin: 10px;
}

.sidebar-footer-label {
  margin: 0;
}

.sidebar-footer-list > .text-link {
  margin-inline: 6px;
  border-radius: var(--in-content-button-border-radius);
}

@media (max-width: 830px) {
  #pref-category-box,
  #categories {
    width: auto;
  }

  #categories > .category {
    padding-inline: 12px;
  }

  #pref-category-box .sidebar-footer-list > .text-link {
    margin-inline: 12px;
  }

  #preferencesContainer {
    padding-inline: 15px;
  }
}

html|input:is([type="email"], [type="tel"], [type="text"], [type="password"], [type="url"]) {
  padding-block: initial;
  /* it should be --in-content-button-height but input doesn't include the border */
  min-height: calc(var(--in-content-button-height) - 2px);
}

html|input[type="number"] {
  margin-inline-start: 4px;
  padding: 1px;
  min-height: calc(var(--in-content-button-height) - 4px);
}
/* sizes: chars + 8px padding + 1px borders + spin buttons 25+2+10px  */
html|input[type="number"].size2 {
  width: calc(2ch + 55px);
}
html|input[type="number"].size3 {
  width: calc(3ch + 55px);
}
html|input[type="number"].size4 {
  width: calc(4ch + 55px);
}
html|input[type="number"].size5 {
  width: calc(5ch + 55px);
}

html|input[type="number"]::-moz-number-spin-box {
  padding-inline-start: 10px;
}

html|input[type="number"]::-moz-number-spin-up,
html|input[type="number"]::-moz-number-spin-down {
  appearance: none;
  min-width: 25px;
  border-color: var(--in-content-box-border-color);
  background-color: var(--in-content-button-background);
  background-position: center;
  -moz-context-properties: stroke;
  stroke: currentColor;
}

html|input[type="number"]::-moz-number-spin-up:hover,
html|input[type="number"]::-moz-number-spin-down:hover {
  background-color: var(--in-content-button-background-hover);
}

html|input[type="number"]::-moz-number-spin-up {
  min-height: calc(var(--in-content-button-height) * 0.5 - 3px);
  border-bottom-width: 1px;
  border-bottom-style: solid;
  border-radius: 1px 1px 0 0;
  background-image: url("chrome://messenger/skin/icons/new/nav-up-sm.svg");
}

html|input[type="number"]::-moz-number-spin-down {
  min-height: calc(var(--in-content-button-height) * 0.5 - 4px);
  border-radius: 0 0 1px 1px;
  background-image: url("chrome://messenger/skin/icons/new/nav-down-sm.svg");
}

separator.groove:not([orient="vertical"]) {
  border-top-color: #c1c1c1;
  border-bottom-width: 0;
}

tab:not([selected="true"]):hover {
  border-bottom-color: transparent;
}

tab:-moz-focusring > .tab-middle {
  outline: none;
}

tab:focus-visible {
  background-color: var(--in-content-button-background);
}

tab:focus-visible > .tab-middle > .tab-text {
  outline: none;
}

#defaultWebSearchPopup > menuitem > .menu-iconic-left {
  display: -moz-box;
}

/* Applications Pane Styles */

#filter {
  margin-inline: 0;
}

/* XXX This style is for bug 740213 and should be removed once that
   bug has a solution. */
description > html|a {
  cursor: pointer;
}
#previewBox {
  height: 220px;
}

.indent,
html|input.indent {
  /* This should match the checkboxes/radiobuttons' width and inline margin,
     such that when we have a toggle with a label followed by another element
     with this class, the other element's text aligns with the toggle label. */
  margin-inline-start: 22px;
}

checkbox {
  margin-inline: 0;
}

.align-no-label {
  margin-inline-start: 4px;
}

.tail-with-learn-more {
  margin-inline-end: 10px;
}

.learnMore {
  margin-inline-start: 0;
  font-weight: normal;
  white-space: nowrap;
}

.update-deck-container {
  display: flex;
  align-items: center;
}

.update-deck-container > * {
  flex: 0 0 auto;
}

.update-deck-container:not(.selected) {
  visibility: hidden;
}

.update-deck-container > button {
  /* Align the button at the end. */
  margin-inline-start: auto;
}

.update-throbber {
  width: 16px;
  height: 16px;
  margin-inline: 6px 4px;
}
 
/* Work around bug 560067 - animated images in visibility: hidden
 * still eat CPU. */
#updateDeck > *:not(.selected) > .update-throbber {
  display: none;
}

.updateSettingCrossUserWarningContainer {
  background: var(--in-content-box-info-background);
  border-radius: 5px;
  padding: 2px 8px 8px;
  margin-block-end: 17px;
}

#updateSettingCrossUserWarning {
  padding-inline-start: 30px;
  margin-block-start: 20px;
  line-height: 20px;
  background-image: url("chrome://messenger/skin/icons/info.svg");
  background-position-x: left 2px;
  background-position-y: top 2px;
  background-size: 16px 16px;
  background-repeat: no-repeat;
  -moz-context-properties: fill;
  fill: currentColor;
}

#updateSettingCrossUserWarning:-moz-locale-dir(rtl) {
  background-position-x: right 2px;
}

#releasenotes {
  margin-inline-start: 6px !important;
}

#telemetry-container {
  border-radius: 4px;
  background-color: rgba(12, 12, 13, 0.2);
  font-size: 85%;
  padding: 3px;
  margin-block: 4px;
  width: 100%;
  display: flex;
}

#telemetry-container[hidden] {
  display: none;
}

#telemetryInfoIcon {
  flex: 0 0 auto;
  align-self: start;
  width: 16px;
  height: 16px;
  padding: 2px;
}

#telemetryDisabledDescription {
  flex: 1 1 auto;
  align-self: start;
  line-height: 1.3;
  margin-inline-start: 6px;
}

#telemetryDataDeletionLearnMore {
  flex: 0 0 auto;
  align-self: center;
}

#submitHealthReportBox {
  display: -moz-inline-box;
}

/* Remove the start margin to align these elements */
#addCloudFileAccount,
#chatStartupAction,
#defaults-itemtype-menulist,
#manageCertificatesButton {
  margin-inline-start: 0;
}

#dictionaryList {
  list-style-type: none;
  padding: 0;
  margin-block: 0.5em;
}

#dictionaryList label {
  display: flex;
  align-items: center;
}

/**
 * Font dialog menulist fixes
 */

#fontsTitle {
  margin-block: 4px;
}

#defaultFontType,
#serif,
#sans-serif,
#monospace {
  min-width: 30ch;
}

/**
 * toolkit element overrides
 */

#preferencesContainer richlistbox {
  appearance: none;
  background-color: var(--in-content-box-background);
  color: var(--in-content-text-color);
}

#preferencesContainer richlistbox richlistitem {
  padding: 0.3em;
  margin: 0;
  border: none;
  border-radius: 0;
  background-image: none;
}

#containerBox richlistbox richlistitem:hover,
#identitiesList richlistbox richlistitem:hover,
#preferencesContainer richlistbox richlistitem:hover {
  background-color: var(--in-content-item-hover);
}

#containerBox richlistitem[selected="true"],
#identitiesList richlistitem[selected="true"],
#preferencesContainer richlistitem[selected="true"] {
  background-color: var(--in-content-item-selected-unfocused);
  color: inherit;
}

#containerBox richlistbox:focus > richlistitem[selected="true"],
#identitiesList:focus > richlistitem[selected="true"],
#preferencesContainer richlistbox:focus > richlistitem[selected="true"] {
  background-color: var(--in-content-item-selected);
  color: var(--in-content-item-selected-text) !important;
}

#defaultWebSearch {
  margin-inline: 0 4px;
}

#defaultFontSize,
#directoriesList,
#localDirectoriesList,
#defaultStartupDirList {
  margin-inline-end: 4px;
}

#messengerLanguagesDialogPane {
  min-height: 360px;
}

#primaryMessengerLocale {
  margin-inline: 0 4px;
  min-width: 20em;
}

#availableLocales {
  margin-inline: 0;
}

#warning-message {
  margin-top: 8px;
}

#warning-message > .message-bar-description {
  width: 32em;
}

.action-button {
  margin-inline-start: 8px;
}

#tagList,
#categorieslist {
  margin-inline-end: 4px;
}

#new-tag-button,
#newCButton {
  margin-top: 0;
}

/* Menulist styles */
.label-item {
  font-size: .8em;
}

.menu-iconic-icon {
  -moz-context-properties: fill;
  fill: currentColor;
}

#datePrefsBox {
  display: grid;
  grid-template-columns: auto 1fr 1fr;
}

#PopupAutoComplete > richlistbox {
  margin: unset;
  border: unset;
  border-radius: unset;
}

/**
 * Connection dialog
 */

#proxyExtensionContent:not([hidden]) {
  display: flex;
  align-items: center;
}

#proxyExtensionDescription {
  margin-block: 0;
  flex: 1 1 auto;
}

#proxyExtensionDescription > img {
  height: 20px;
  width: 20px;
  vertical-align: text-bottom;
  -moz-context-properties: fill;
  fill: currentColor;
}

#proxyExtensionDisable {
  flex: 0 0 auto;
}

#proxy-grid,
#dnsOverHttps-grid {
  display: grid;
  grid-template-columns: auto 1fr;
  align-items: center;
}

.proxy-grid-row:not([hidden]),
.dnsOverHttps-grid-row:not([hidden]) {
  display: contents;
}

#proxy-grid > .thin {
  grid-column: span 2;
  height: 20px;
}

calendar-notifications-setting {
  display: flex;
  flex-direction: column;
  margin-bottom: 9px;
}

calendar-notifications-setting .add-button {
  list-style-image: url(chrome://global/skin/icons/add.svg);
  fill: currentColor;
  -moz-context-properties: fill;
}

calendar-notifications-setting .add-button .button-icon {
  margin-inline-end: 6px;
}

calendar-notifications-setting .remove-button {
  width: 32px;
  min-width: 0;
  padding: 0;
  list-style-image: url(chrome://global/skin/icons/delete.svg);
  fill: currentColor;
  background: none;
  -moz-context-properties: fill;
  --in-content-button-horizontal-padding: 0;
}

/**
 * End connection dialog
 */
